// drawing elements in game modes

// variables
color colorI = color(44, 209, 255);
color colorO = color(255, 217, 59);
color colorL = color(255, 156, 35);
color colorJ = color(68, 124, 255);
color colorT = color(232, 76, 201);
color colorS = color(134, 234, 57);
color colorZ = color(255, 67, 92);
color colorGh = color(225, 225, 225);	// ghost fill color
int strokeGh = 120;		// ghost stroke color
color colorGb = color(150, 150, 150);	// garbage
color colorB1 = color(100, 100, 100);	// bomb
color colorB2 = color(200, 200, 200);
color colorB3 = color(255, 30, 30);
color BGColor = color(180, 180, 180);	//background color

void drawField() {
	// draw boxes
	fill(255);
	stroke(0);
	rect(275, 50, 250, 500);  // empty play field

	// draw play field
	fill(0);
	stroke(0);
	for (int i=0; i<10; i++) {
		for (int j=0; j<20; j++) {
			// set fill color & draw them in
			switch(playField[i][j]) {
				case 0:	// I
					fill(colorI);
					rect(275+(25*i), 525-(25*j), 25, 25);
					break;
				case 1: // O
					fill(colorO);
					rect(275+(25*i), 525-(25*j), 25, 25);
					break;
				case 2: // L
					fill(colorL);
					rect(275+(25*i), 525-(25*j), 25, 25);
					break;
				case 3: // J
					fill(colorJ);
					rect(275+(25*i), 525-(25*j), 25, 25);
					break;
				case 4: // T
					fill(colorT);
					rect(275+(25*i), 525-(25*j), 25, 25);
					break;
				case 5: // S
					fill(colorS);
					rect(275+(25*i), 525-(25*j), 25, 25);
					break;
				case 6: // Z
					fill(colorZ);
					rect(275+(25*i), 525-(25*j), 25, 25);
					break;
				case 7: // garbage
					fill(colorGb);
					rect(275+(25*i), 525-(25*j), 25, 25);
					break;
				case 8: // bomb
					fill(colorB1);
					stroke(0);
					rect(275+(25*i), 525-(25*j), 25, 25);
					fill(colorB2);
					rect(279+(25*i), 529-(25*j), 17, 17);
					fill(colorB3);
					ellipse(282+(25*i), 532-(25*j), 11, 11);
					break;
				default:	// 9 = nothing there
					break;
			}
		}
	}
	drawGrids();
}

void drawHold() {
	fill(255);
	stroke(0);
	rect(150, 70, 100, 100);	// hold box
	int offset[] = {0, 0};
	if (holdPiece == 0) {
		offset[0] = -13;
		offset[1] = -13;
	} else if (holdPiece == 1) {
		offset[0] = -12;
	}
	drawMino(188+offset[0], 120+offset[1], holdPiece, 0, false);
}

void drawPreview() {
	fill(255);
	stroke(0);
	rect(550, 50, 100, 400);  // preview box
	int offset[] = {0, 0};
	for (int i=0; i<5; i++) {
		if (pieceSequence[i] == 0) {
			offset[0] = -13;
			offset[1] = -13;
		} else if (pieceSequence[i] == 1) {
			offset[0] = -12;
			offset[1] = 0;
		} else {
			offset[0] = 0;
			offset[1] = 0;
		}
		drawMino(588+offset[0], 100+offset[1]+75*i, pieceSequence[i],
			0, false);
	}
}

void drawGrids() {
	stroke(220);
	for (int i=300; i<525; i+=25) {
		line (i, 51, i, 549);
	}
	for (int i=75; i<550; i+=25) {
		line (276, i, 524, i);
	}
}

void drawPlayPiece() {
	
	// draw ghost first, then the tetromino itself
	int ghostY = currentY;
	while(!isOccupied(currentX, ghostY-1, currentMino, currentRotation)) {
		ghostY--;
	}
	drawMino(275+25*currentX, 525-25*ghostY, currentMino, currentRotation,
	true);
	drawMino(275+25*currentX, 525-25*currentY, currentMino, currentRotation,
	false);
}

void drawMino(int posX, int posY, int minoType, int minoRotation,
		boolean isGhost) {
	if (minoType == 9)
		return;
	if (isGhost) {
		stroke(strokeGh);
		fill(colorGh);
	} else {
		stroke(0);
		switch(minoType) {
			case 0:	// I
				fill(colorI);
				break;
			case 1: // O
				fill(colorO);
				break;
			case 2: // L
				fill(colorL);
				break;
			case 3: // J
				fill(colorJ);
				break;
			case 4: // T
				fill(colorT);
				break;
			case 5: // S
				fill(colorS);
				break;
			case 6: // Z
				fill(colorZ);
				break;
			default:
				break;
		}
	}

	for (int i=0; i<4; i++) {
		int drawPosX = posX + 25*tetromino[minoType][minoRotation][i][0];
		int drawPosY = posY - 25*tetromino[minoType][minoRotation][i][1];
		if (drawPosY >= 50)
			rect(drawPosX, drawPosY, 25, 25);
	}

	// fix play field box after drawing Ghost
	if (isGhost) {
		stroke(0);
		line(275, 50, 525, 50);
		line(275, 50, 275, 550);
		line(525, 50, 525, 550);
		line(275, 550, 525, 550);
	}
}
